import { CommandContext, CommandOptionType, SlashCommand, SlashCreator } from 'slash-create'

export default class RPSCommand extends SlashCommand {
  constructor(creator: SlashCreator) {
    super(creator, {
      name: 'rps',
      description: 'play rock paper scissors',
      options: [
        {
          name: 'choice',
          description: 'what you want to play',
          type: CommandOptionType.STRING,
          choices: [
            { name: 'rock', value: 'rock' },
            { name: 'paper', value: 'paper' },
            { name: 'scissors', value: 'scissors' }
          ],
          required: true
        }
      ]
    })
  }

  async run(ctx: CommandContext) {
    const uc = ctx.options.choice
    const cc = ['rock', 'paper', 'scissors'][Math.floor(Math.random() * 3)]
    let winner = ''
    if (uc == cc) {
      winner = "it's a tie!"
    } else if (
      (uc == 'rock' && cc == 'scissors') ||
      (uc == 'paper' && cc == 'rock') ||
      (uc == 'scissors' && cc == 'paper')
    ) {
      winner = 'you win!'
    } else {
      winner = 'computer wins!'
    }
    return `you chose ${uc} and the computer chose ${cc}. ${winner}`
  }
}
