import { PrismaClient } from '@prisma/client';
import { CommandContext, CommandOptionType, SlashCommand, SlashCreator } from 'slash-create';

export default class ToggleWelcomerCommand extends SlashCommand {
  constructor(creator: SlashCreator) {
    super(creator, {
      name: 'toggle_welcomer',
      description: 'toggle the welcome',
      options: [
        {
          name: 'setting',
          type: CommandOptionType.BOOLEAN,
          description: 'whether it is on or not (leave blank to see the current setting)'
        }
      ]
    })
  }

  async run(ctx: CommandContext) {
    const p = new PrismaClient()
    if (ctx.options.setting == null) {
      const gcf = await p.guildConfig.findFirst({
        where: {
          id: ctx.guildID
        }
      })

      return `the welcomer is currently ${gcf.welcome_on ? 'on' : 'off'}`
    }

    await p.guildConfig.update({
      where: {
        id: ctx.guildID
      },
      data: {
        welcome_on: ctx.options.setting
      }
    })

    return `set welcomer to ${ctx.options.setting ? 'on' : 'off'}`
  }
}
